using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel; 

namespace GridFeatures
{    
    public class Employee
    {
        private int empid;
        private EmployeeDetailsCollection  empdetailsColl = null;
        public int EmpID
        {
           get { return this.empid; }
           set { this.empid = value; }
        }
        public Employee(int empid)
		{
			this.empid = empid;		
		}
        public EmployeeDetailsCollection EmpDetailsColl
        {
            get
			{
                if (this.empdetailsColl == null)
                    this.empdetailsColl = new EmployeeDetailsCollection();

                return this.empdetailsColl;
		    }          
        }      
    }

    public class EmployeeDetails
    {
        private string firstName;
        private string lastName;
        private int age;
        private bool male;
        private DateTime dob;
        private string occupation;

        #region Constructor
        public EmployeeDetails(string firstname, string lastname, int age, bool male, DateTime dob, string occupation)
		{
			this.firstName = firstname;
			this.lastName = lastname;
            this.age = age;
            this.male = male;
            this.dob = dob;
            this.occupation = occupation;
		}
		#endregion Constructor

        public string FirstName
         {
            get { return this.firstName; }
            set { this.firstName = value; }
         }         
        public string LastName
         {
            get { return this.lastName; }
            set { this.lastName = value; }
         }      
        public int Age
         {
            get { return this.age; }
            set { this.age = value; }
         }       
        public bool Male
         {
            get { return this.male; }
            set { this.male = value; }
         }      
        public DateTime DOB
         {
            get { return this.dob; }
            set { this.dob = value; }
         }        
        public string Occupation
         {
            get { return this.occupation; }
            set { this.occupation = value; }
         }         
    }

    #region EmployeeCollection

    public class EmployeeCollection : System.Collections.CollectionBase
    {
        public Employee Add(int empid)
        {
            Employee newemployee = new Employee(empid);
            this.List.Add(newemployee);
            return newemployee;
        }
    }

    #endregion EmployeeCollection

    #region EmployeeDetailsCollection

    public class EmployeeDetailsCollection : System.Collections.CollectionBase  
    {
        public EmployeeDetails Add(string firstname, string lastname, int age, bool male, DateTime dob, string occupation)
        {
            EmployeeDetails empdetails = new EmployeeDetails(firstname, lastname, age, male, dob, occupation);     
            this.List.Add(empdetails);
            return empdetails;
        }
    }

    #endregion EmployeeDetailsCollection
}
