using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Infragistics.Shared;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win.UltraWinEditors;

namespace GridFeatures
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        ValueList vl = new ValueList();    
        BindingList<string> blOccupation = new BindingList<string>();
        EmployeeCollection empColl = new EmployeeCollection();
        Employee emp;

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            // Turn on all of the Cut, Copy, and Paste functionality. 
            e.Layout.Override.AllowMultiCellOperations = AllowMultiCellOperation.All;

            // In order to cut or copy, the user needs to select cells or rows. 
            // So set CellClickAction so that clicking on a cell selects that cell
            // instead of going into edit mode.
            e.Layout.Override.CellClickAction = CellClickAction.CellSelect;

            e.Layout.Bands[0].Columns["EmpID"].Header.Caption = "My Employee ID";
            e.Layout.Bands[1].Columns["FirstName"].Header.Caption = "My First Name";
            e.Layout.Bands[1].Columns["LastName"].Header.Caption = "My Last Name";
            e.Layout.Bands[1].Columns["Age"].Header.Caption = "My Age";
            e.Layout.Bands[1].Columns["Male"].Header.Caption = "My Sex";
            e.Layout.Bands[1].Columns["DOB"].Header.Caption = "My DOB";
            e.Layout.Bands[1].Columns["Occupation"].ValueList = ultraDropDown1;    

        }

        private void Form1_Load(object sender, EventArgs e)
        {
            emp = empColl.Add(1);
            emp.EmpDetailsColl.Add("Mike", "Jack", 32, true, DateTime.Today, "Engineer");

            emp = empColl.Add(2);
            emp.EmpDetailsColl.Add("Rosy", "Mark", 28, true, DateTime.Today, "Senior Engineer");

            emp = empColl.Add(3);
            emp.EmpDetailsColl.Add("Amy", "Joesph", 30, true, DateTime.Today, "Tech Lead");

            emp = empColl.Add(4);
            emp.EmpDetailsColl.Add("Stella", "Mary", 29, true, DateTime.Today, "Team Lead");

            emp = empColl.Add(5);
            emp.EmpDetailsColl.Add("Ben1", "Thomson1", 31, true, DateTime.Today, "Project Lead");
            emp.EmpDetailsColl.Add("Ben2", "Thomson2", 32, true, DateTime.Today, "Project Lead");   
            emp.EmpDetailsColl.Add("Ben3", "Thomson3", 33, true, DateTime.Today, "Project Lead");   
            emp.EmpDetailsColl.Add("Ben4", "Thomson4", 34, true, DateTime.Today, "Project Lead");   
           
            ultraGrid1.DataSource = empColl;

            blOccupation.Add("Engineer");
            blOccupation.Add("Senior Engineer");
            blOccupation.Add("Tech Lead");
            blOccupation.Add("Team Lead");
            blOccupation.Add("Project Lead");
            blOccupation.Add("Engineering Manager");
            ultraDropDown1.DataSource = blOccupation;      
        }

        private void cmGridOpearation_ItemClicked(object sender, ToolStripItemClickedEventArgs e)
        {
            switch(e.ClickedItem.Text)  
            {
                case "Cut":this.ultraGrid1.PerformAction(Infragistics.Win.UltraWinGrid.UltraGridAction.Cut);
                     break;
                 case "Copy":this.ultraGrid1.PerformAction(Infragistics.Win.UltraWinGrid.UltraGridAction.Copy);
                    break;
                case "Paste":this.ultraGrid1.PerformAction(Infragistics.Win.UltraWinGrid.UltraGridAction.Paste);
                    break;
                case "Undo":this.ultraGrid1.PerformAction(Infragistics.Win.UltraWinGrid.UltraGridAction.Undo);
                    break;
                case "Redo":this.ultraGrid1.PerformAction(Infragistics.Win.UltraWinGrid.UltraGridAction.Redo);
                    break; 
            }
        }

        private void ultraGrid1_MouseDown(object sender, MouseEventArgs e)
        {
            UltraGrid grid = (UltraGrid)sender;
            RowSelectorHeaderUIElement rowSelectorHeaderUIElement = grid.DisplayLayout.UIElement.LastElementEntered as RowSelectorHeaderUIElement;
            if (rowSelectorHeaderUIElement != null)
            {
                this.ultraGrid1.Selected.Rows.AddRange(this.ultraGrid1.Rows.GetFilteredInNonGroupByRows());
            }
        }

        private void ultraGrid1_AfterPerformAction(object sender, AfterUltraGridPerformActionEventArgs e)
        {
            UpdateButtonEnabledStates(); 
        }

        private void ultraGrid1_AfterSelectChange(object sender, AfterSelectChangeEventArgs e)
        {
            UpdateButtonEnabledStates(); 
        }

        #region CanPerformAction
        private bool CanPerformAction(UltraGridAction action)
        {
            // The KeyActionMappings will reveal whether or not the 
            // action is valid based on the current state of the grid. 
            return this.ultraGrid1.KeyActionMappings.IsActionAllowed(action, (long)this.ultraGrid1.CurrentState);
        }
        #endregion CanPerformAction

        #region UpdateButtonEnabledStates
        private void UpdateButtonEnabledStates()
        {
            this.copyToolStripMenuItem.Enabled = this.CanPerformAction(UltraGridAction.Copy);
            this.cutToolStripMenuItem.Enabled = this.CanPerformAction(UltraGridAction.Cut);
            this.pasteToolStripMenuItem.Enabled = this.CanPerformAction(UltraGridAction.Paste);

            this.undoToolStripMenuItem.Enabled = this.CanPerformAction(UltraGridAction.Undo);
            this.redoToolStripMenuItem.Enabled = this.CanPerformAction(UltraGridAction.Redo);
          
        }
        #endregion UpdateButtonEnabledStates

        private void ubAdd_Click(object sender, EventArgs e)
        {
            emp = empColl.Add(6);
            emp.EmpDetailsColl.Add("Karl", "Anderson", 35, true, DateTime.Today, "Engineering Manager");
            ultraGrid1.DataSource = empColl;
        }
        private void ubDelete_Click(object sender, EventArgs e)
        {
            //How to Implement deleting of rows.
        }        
    }
}